/// <reference types="koa__router" />
import type { Middleware, ParameterizedContext, DefaultState } from 'koa';
import { InstrumentationConfig } from '@opentelemetry/instrumentation';
import type { RouterParamContext } from '@koa/router';
import type * as Router from '@koa/router';
export declare const kLayerPatched: unique symbol;
export declare type KoaMiddleware = Middleware<DefaultState, KoaContext> & {
    [kLayerPatched]?: boolean;
    router?: Router;
};
export declare type KoaContext = ParameterizedContext<DefaultState, RouterParamContext>;
export declare enum KoaLayerType {
    ROUTER = "router",
    MIDDLEWARE = "middleware"
}
export declare const KoaComponentName = "koa";
export declare type IgnoreMatcher = string | RegExp | ((name: string) => boolean);
export interface EggInstrumentationConfig extends InstrumentationConfig {
    ignoreLayers?: IgnoreMatcher[];
    ignoreLayersType?: KoaLayerType[];
}
